# Copyright (c) 2010-2011 Outpost Embedded, LLC
# This file is part of the pydbusclone software package.
#
# pydbusclone is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License version 2 as published by the
# Free Software Foundation.
#
# A copy of the license has been included in the COPYING file.

_mainloop_type = None


_call_in_main_thread = None


def set_mainloop_type(value):
    global _mainloop_type
    global _call_in_main_thread

    if value not in ('glib', 'qt'):
        raise ValueError(value)

    _mainloop_type = value

    if value == 'glib':
        from dbusclone.mainloop.glib_ import call_in_main_thread
    elif value == 'qt':
        from dbusclone.mainloop.qt_ import call_in_main_thread

    _call_in_main_thread = call_in_main_thread


def call_in_main_thread(*args, **kwargs):
    if not callable(_call_in_main_thread):
        raise AssertionError('must call set_mainloop_type')
    return _call_in_main_thread(*args, **kwargs)
