# Copyright (c) 2010-2011 Outpost Embedded, LLC
# This file is part of the pydbusclone software package.
#
# pydbusclone is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License version 2 as published by the
# Free Software Foundation.
#
# A copy of the license has been included in the COPYING file.

import sys

import glib
from dbus.mainloop.glib import DBusGMainLoop
import dbus
from dbusclone.mainloop import set_mainloop_type
from dbusclone.apps.connman import ConnmanManager


DBusGMainLoop(set_as_default = True)
bus = dbus.SystemBus()
set_mainloop_type('glib')
mainloop = glib.MainLoop()


def handle_error(e):
    print >>sys.stderr, 'ERROR: %s' % e


def manager_ready(manager):
    for service in manager.services.iter_objects():
        props = service.properties.getdict()
        print props['Name']
        for k, v in props.items():
            if isinstance(v, dbus.Array):
                v = ', '.join(v)
            elif isinstance(v, dbus.Dictionary):
                v = '[DICTIONARY]'
            print '  %s: %s' % (k, v)
    mainloop.quit()


ConnmanManager(
  bus = bus,
  ready_callback = manager_ready,
  default_error_handler = handle_error,
)


mainloop.run()
